package com.szpg.plc.message.response.read;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import com.szpg.db.dao.PgAlarmDao;
import com.szpg.db.dao.PgAlarmRuleDao;
import com.szpg.db.dao.PgCODao;
import com.szpg.db.dao.PgDeviceDao;
import com.szpg.db.dao.impl.PgAlarmDaoImpl;
import com.szpg.db.dao.impl.PgAlarmRuleDaoImpl;
import com.szpg.db.dao.impl.PgCODaoImpl;
import com.szpg.db.dao.impl.PgDeviceDaoImpl;
import com.szpg.db.data.PgAlarm;
import com.szpg.db.data.PgAlarmRule;
import com.szpg.plc.message.response.ReadMemoryCommandResponse;
import com.szpg.util.Configure;
import com.szpg.util.DataPushInterface;
import com.szpg.util.NumberFormat;
import com.szpg.util.TimeFormat;

public class ReadCOValueCommandResponse extends ReadMemoryCommandResponse {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6176747812714170040L;

	private final Logger logger = Logger.getLogger(this.getClass().getName());
	
	private List<Float> cond; //一氧化碳浓度值
	private List<Float> coldbjz; //一氧化碳联动报警值
	private String[] zcList; //一氧化碳监测的资产列表，从配置文件中获取
	
	public ReadCOValueCommandResponse() {
		cond = new ArrayList<Float>();
		coldbjz = new ArrayList<Float>();
	}

	public List<Float> getCond() {
		return cond;
	}

	public void setCond(List<Float> cond) {
		this.cond = cond;
	}

	public List<Float> getColdbjz() {
		return coldbjz;
	}

	public void setColdbjz(List<Float> coldbjz) {
		this.coldbjz = coldbjz;
	}
	
	public String[] getZcList() {
		return zcList;
	}

	public void setZcList(String[] zcList) {
		this.zcList = zcList;
	}

	@Override
	public void afterAction() {
		// 1将一氧化碳浓度数据存入数据库
		PgCODao coDao = new PgCODaoImpl();
		PgDeviceDao deviceDao = new PgDeviceDaoImpl();
		PgAlarmRuleDao ruleDao = new PgAlarmRuleDaoImpl();
		PgAlarmDao alarmDao = new PgAlarmDaoImpl();
		
		if (null != zcList && zcList.length > 0) {
			// 遍历一氧化碳设备列表，将一氧化碳浓度监测值存入数据库
			for (int i = 0; i < zcList.length; i++) {
				String zcbh = zcList[i];
				
				float value = cond.get(i);
				
				int deviceId = deviceDao.findDeviceIdByCode(zcbh);
				if (deviceId > 0) {
					coDao.addPblzRecord(cond.get(i), TimeFormat.formatTimestamp(this.getTime().getTime()), deviceId);
					
					// (一)如果有报警则立即推送
					// 判断是否超过报警阈值
					PgAlarmRule rule = ruleDao.findRuleByDevice(deviceId);
					if (null != rule) {
						double high = 0.0;
						try {
							high = NumberFormat.parseDouble(rule.getHighvalue(), "0.00");
						} catch (Exception ex) {
							logger.error(ex);
							ex.printStackTrace();
						}
						
						// 一氧化碳浓度超过高限阈值
						if (high > 0.0001 && value > high) {
							PgAlarm alarm = new PgAlarm();
							alarm.setActive(1);
							alarm.setAlarm_date(this.getTime().getTime());
							alarm.setAlarm_value(NumberFormat.format(value, "0.00"));
							alarm.setAlarmdevid(deviceId);
							alarm.setAlarmtypeid(PgAlarm.ALARM_TYPE_PGRUN);
							alarm.setDescription("一氧化碳浓度超过高限阈值");
							alarm.setUserid(null);
							
							alarmDao.insertAlarmRecord(alarm);
							deviceDao.updateDeviceStatus(deviceId, "一氧化碳浓度过高");
							
							// 将报警日志推送至市级平台
							String date = TimeFormat.formatDate(getTime().getTime());
							int count = alarmDao.findAlarmCountByDate(date);
							String bjbh = "THXC." + date + "." + NumberFormat.format(count+1, "0000");
							String bjms = alarm.getDescription() + "，一氧化碳浓度值为" + value;
							String bjsj = date.replace("-", "");
							String jwbjResp = DataPushInterface.addCOAlarmData(bjbh, zcbh, bjms, bjsj);
							logger.info("同步一氧化碳报警记录日志结果：" + jwbjResp);
							
							// 将报警值推送至市级平台
							String jwResp = DataPushInterface.addCOData(zcbh, NumberFormat.format(value, "0.00"), TimeFormat.format(this.getTime().getTime(), "yyyyMMddHHmmss"));
							logger.info("同步一氧化碳浓度值结果：" + jwResp);

							// 一氧化碳不需要联动控制风机
						}
					}
					
					
					// (二)如果监测值有变化则推送
					// 判断一氧化碳浓度值是否有变化
					double lastValue = coDao.findLastValueByDevice(deviceId);
					if (Math.abs(value - lastValue) > 0.01) {
						// 将监测值推送至市级平台
						String coResp = DataPushInterface.addCOData(zcbh, NumberFormat.format(value, "0.00"), TimeFormat.format(this.getTime().getTime(), "yyyyMMddHHmmss"));
						logger.info("同步一氧化碳浓度值结果：" + coResp);
					}
					
					// (三)如果监测值有变化则推送
					// 每天小时各推送一个数据
					int minute = Calendar.getInstance().get(Calendar.MINUTE);
					if (minute < 10) {
						// 将监测值推送至市级平台
						String coResp = DataPushInterface.addCOData(zcbh, NumberFormat.format(value, "0.00"), TimeFormat.format(this.getTime().getTime(), "yyyyMMddHHmmss"));
						logger.info("同步一氧化碳浓度值结果：" + coResp);
					}
				} else {
					logger.warn("未找到资产[" + zcbh + "]");
				}
			}
		}
	}

	@Override
	public void parseData() {
		// 获取目标ACU的代码
		String acucode = this.getAcucode();
		byte[] messageData = this.getResponseData();
		
		logger.info("开始解析[读取一氧化碳浓度值][" + acucode + "]指令响应");
		
		// 判断数据的长度是否满足要求
		if (messageData.length != Integer.parseInt(Configure.getProperty("acubl", acucode + ".CO.WORDCOUNT")) * 2) {
			logger.error("返回的数据长度与读取的不一致！");
			this.setValid(false);
			return;
		}
		
		// 获取目标ACU一氧化碳监测值内存区域的起始字地址
		int start = Integer.parseInt(Configure.getProperty("acubl", acucode + ".CO.START"));
		
		// 获取目标ACU一氧化碳相关的资产列表，即一氧化碳设备列表
		String zcListStr = Configure.getProperty("acubl", acucode + ".CO.ZC.LIST");
		if (StringUtils.isEmpty(zcListStr) == true) {
			this.setValid(false);
			return;
		}
		zcList = zcListStr.split(";");
		
		// 解析一氧化碳浓度监测值以及一氧化碳浓度报警阈值
		for (int i = 0; i < zcList.length; i++) {
			String zcbh = zcList[i];
			
			// 1解析一氧化碳浓度监测值
			float value = getValueFromData(zcbh, start, messageData, zcbh + ".Value");
			
			// 2解析一氧化碳浓度报警阈值
			float threshold = getValueFromData(zcbh, start, messageData, zcbh + ".Set");
			
			getCond().add(value);
			getColdbjz().add(threshold);
			
			logger.info("[" + zcbh + "][一氧化碳浓度值" + value + "][一氧化碳浓度报警阈值" + threshold + "]");
		}
		
		logger.info("解析[读取一氧化碳浓度值]响应指令结束");
	}

}
